/*
	Program cats wav files into output wav file.
	wav setup is taken from first cated wav file.
*/
#include <unistd.h>
#include <stdio.h>
#include <sndfile.h>

#define MAX_FRAMES 1638400

struct frame {
	short left ;
	short right ;
} ;

int main ( int argc, const char ** argv ) {

	char * filename ;
	char * outfile ;
	SNDFILE *audiofile ;
	SNDFILE *newaudiofile ;
	SF_INFO sfinfo ;
	struct frame Frames[MAX_FRAMES] ;
	size_t inframes, outframes ;
	int i, j ;

	newaudiofile = NULL ;
	
	if (( argc < 4 ) || (strcmp ( argv[1] ,"-o"))) {
		printf ( "Usage: %s -o outfile filename(s)\n" , argv[0] ) ;
		return 1;		
	} 
	
	if ( argv[2] ) {
		outfile = (char *)argv[2] ;
	} else {
		printf ( "Usage: %s -o outfile filename(s)\n" , argv[0] ) ;
		return 1;
	}

	for ( j = 3 ; j < argc; j++ ) {
		filename = (char *)argv[j];
		audiofile = sf_open_read ( filename, &sfinfo ) ;
		if ( ! newaudiofile ) {
			newaudiofile = sf_open_write ( outfile , &sfinfo ) ;
		}
		i = 0;
		while ( i < sfinfo.samples ) {
			inframes = sf_readf_short ( audiofile,(short *) &Frames , MAX_FRAMES ) ;
			outframes = sf_writef_short ( newaudiofile, (short *)&Frames , inframes ) ;
			i += inframes ;
		}
		sf_close ( audiofile ) ;
	}
	sf_close ( newaudiofile ) ;	
	return 0 ;
}
